// controllers/user.js

const sql = require('mssql');

const get_user = async (req, res) => {
  const imeiNumber = req.query.imei;
  console.log('IMEI Number:', imeiNumber);

  try {
    const request = new sql.Request();
    const query = `SELECT COUNT(*) AS count, mobileNumber FROM UserDetails WHERE imeiNumber = '${imeiNumber}' GROUP BY mobileNumber`;
    const result = await request.query(query);

    if (result.recordset.length > 0) {
      const data = { 
        message: 'IMEI number exists in the database',
        mobileNumbers: result.recordset.map(row => row.mobileNumber)
      };
      res.json(data);
    } else {
      const data = { message: 'IMEI number does not exist in the database' };
      res.json(data);
    }
  } catch (error) {
    console.log('Error:', error);
    const data = { message: 'An error occurred' };
    res.status(500).json(data);
  }
};


const post_add_user = async (req, res) => {
  const { imeiNumbers, mobileNumber } = req.body;
  console.log('IMEI Numbers:', imeiNumbers);
  console.log('Mobile Number:', mobileNumber);

  try {
    const request = new sql.Request();

    const query = `
      MERGE INTO UserDetails AS target
      USING (
        SELECT ${mobileNumber} AS mobileNumber
      ) AS source
      ON (target.mobileNumber = source.mobileNumber)
      WHEN MATCHED THEN
        UPDATE SET target.imeiNumber = CONCAT(target.imeiNumber, ', ', '${imeiNumbers.join(', ')}')
      WHEN NOT MATCHED THEN
        INSERT (mobileNumber, imeiNumber)
        VALUES (${mobileNumber}, '${imeiNumbers.join(', ')}');
    `;

    await request.query(query);

    const response = { success: true };
    res.json(response);
  } catch (error) {
    console.log('Error:', error);
    const response = { success: false };
    res.json(response);
  }
};


module.exports = { get_user, post_add_user };
